<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>StateMachineUtil xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../apidocs/org/eclipse/papyrus/designer/transformation/library/xtend/StateMachineUtil.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.transformation.library.xtend;
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <strong class="jxr_keyword">import</strong> java.util.Collection;
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.BasicEList;
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.common.base.ElementUtils;
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.templates.TemplateUtils;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.transformations.TransformationContext;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.PackageUtil;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.NamedElement;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Package;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.PackageableElement;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Pseudostate;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.PseudostateKind;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Region;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.State;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.StateMachine;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.TemplateBinding;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Transition;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Type;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.UMLPackage;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Vertex;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/library/xtend/StateMachineUtil.html">StateMachineUtil</a> {
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Region region(State state) {
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  		EList&lt;Region&gt; regions = state.getRegions();
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  		<strong class="jxr_keyword">if</strong> (regions.size() &gt; 0) {
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  			<strong class="jxr_keyword">return</strong> regions.get(0);
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  		}
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  	}
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Region region(StateMachine stateMachine) {
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  		EList&lt;Region&gt; regions = stateMachine.getRegions();
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  		<strong class="jxr_keyword">if</strong> (regions.size() &gt; 0) {
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  			<strong class="jxr_keyword">return</strong> regions.get(0);
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  		}
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  	}
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> EList&lt;State&gt; subStates(State state) {
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  		Region region = region(state);
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  		<strong class="jxr_keyword">return</strong> (region != <strong class="jxr_keyword">null</strong>) ? states(region) : <strong class="jxr_keyword">new</strong> BasicEList&lt;State&gt;();
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  	}
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> EList&lt;State&gt; states(StateMachine stateMachine) {
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  		Region region = region(stateMachine);
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  		<strong class="jxr_keyword">return</strong> (region != <strong class="jxr_keyword">null</strong>) ? states(region) : <strong class="jxr_keyword">new</strong> BasicEList&lt;State&gt;();
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  	}
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> EList&lt;State&gt; states(Region region) {
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  		EList&lt;State&gt; states = <strong class="jxr_keyword">new</strong> BasicEList&lt;State&gt;();
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  		<strong class="jxr_keyword">for</strong> (org.eclipse.uml2.uml.Vertex vertex : region.getSubvertices()) {
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  			<strong class="jxr_keyword">if</strong> (vertex instanceof State) {
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  				states.add((State) vertex);
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  			}
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  		}
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  		<strong class="jxr_keyword">return</strong> states;
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  	}
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> EList&lt;Pseudostate&gt; entryPoints(State state) {
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  		EList&lt;Pseudostate&gt; pseudoStates = <strong class="jxr_keyword">new</strong> BasicEList&lt;Pseudostate&gt;();
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  		<strong class="jxr_keyword">for</strong> (Pseudostate pseudoState : state.getConnectionPoints()) {
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  			<strong class="jxr_keyword">if</strong> (pseudoState.getKind() == PseudostateKind.ENTRY_POINT_LITERAL) {
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  				pseudoStates.add(pseudoState);
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  			}
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  		}
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  		<strong class="jxr_keyword">return</strong> pseudoStates;
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  	}
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> EList&lt;Pseudostate&gt; exitPoints(State state) {
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  		EList&lt;Pseudostate&gt; pseudoStates = <strong class="jxr_keyword">new</strong> BasicEList&lt;Pseudostate&gt;();
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  		<strong class="jxr_keyword">for</strong> (Pseudostate pseudoState : state.getConnectionPoints()) {
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  			<strong class="jxr_keyword">if</strong> (pseudoState.getKind() == PseudostateKind.EXIT_POINT_LITERAL) {
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  				pseudoStates.add(pseudoState);
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  			}
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  		}
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  		<strong class="jxr_keyword">return</strong> pseudoStates;
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  	}
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> EList&lt;Pseudostate&gt; junctionPoints(Region region) {
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  		<strong class="jxr_keyword">return</strong> filteredPseudoStates(region, PseudostateKind.JUNCTION_LITERAL);
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  	}
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> EList&lt;Pseudostate&gt; choicePoints(Region region) {
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  		<strong class="jxr_keyword">return</strong> filteredPseudoStates(region, PseudostateKind.CHOICE_LITERAL);
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  	}
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> EList&lt;Pseudostate&gt; filteredPseudoStates(Region region, PseudostateKind kind) {
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  		EList&lt;Pseudostate&gt; pseudoStates = <strong class="jxr_keyword">new</strong> BasicEList&lt;Pseudostate&gt;();
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  		<strong class="jxr_keyword">for</strong> (Vertex vertex : region.getSubvertices()) {
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 			<strong class="jxr_keyword">if</strong> (vertex instanceof Pseudostate) {
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 				Pseudostate pseudoState = (Pseudostate) vertex;
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 				<strong class="jxr_keyword">if</strong> (pseudoState.getKind() == kind) {
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 					pseudoStates.add(pseudoState);
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 				}
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 			}
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 		}
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 		<strong class="jxr_keyword">return</strong> pseudoStates;
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 	}
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Pseudostate firstPseudoState(Region region, PseudostateKind kind) {
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 		<strong class="jxr_keyword">for</strong> (Vertex vertex : region.getSubvertices()) {
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 			<strong class="jxr_keyword">if</strong> (vertex instanceof Pseudostate) {
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 				Pseudostate pseudoState = (Pseudostate) vertex;
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 				<strong class="jxr_keyword">if</strong> (pseudoState.getKind() == kind) {
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 					<strong class="jxr_keyword">return</strong> pseudoState;
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 				}
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 			}
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 		}
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 	}
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L123" href="#L123">123</a> <em class="jxr_javadoccomment">	 * @return The set of all transitions ending indirectly on the state.</em>
<a class="jxr_linenumber" name="L124" href="#L124">124</a> <em class="jxr_javadoccomment">	 *         This is, those which end on one of the state's entry points.</em>
<a class="jxr_linenumber" name="L125" href="#L125">125</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Collection&lt;Transition&gt; indirectIncomings(State state) {
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 		EList&lt;Transition&gt; indirectIncoming = <strong class="jxr_keyword">new</strong> BasicEList&lt;Transition&gt;();
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 		<strong class="jxr_keyword">for</strong> (Pseudostate p : entryPoints(state)) {
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 			<strong class="jxr_keyword">for</strong> (Transition t : p.getIncomings()) {
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 				indirectIncoming.add(t);
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 			}
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 		}
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 		<strong class="jxr_keyword">return</strong> indirectIncoming;
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 	}
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L137" href="#L137">137</a> <em class="jxr_javadoccomment">	 * @return The set of all transitions ending indirectly on the state.</em>
<a class="jxr_linenumber" name="L138" href="#L138">138</a> <em class="jxr_javadoccomment">	 *         This is, those which end on one of the state's entry points.</em>
<a class="jxr_linenumber" name="L139" href="#L139">139</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Collection&lt;Transition&gt; indirectOutgoings(State state) {
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 		EList&lt;Transition&gt; indirectIncoming = <strong class="jxr_keyword">new</strong> BasicEList&lt;Transition&gt;();
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 		<strong class="jxr_keyword">for</strong> (Pseudostate p : entryPoints(state)) {
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 			<strong class="jxr_keyword">for</strong> (Transition t : p.getIncomings()) {
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 				indirectIncoming.add(t);
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 			}
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 		}
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 		<strong class="jxr_keyword">return</strong> indirectIncoming;
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 	}
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L152" href="#L152">152</a> <em class="jxr_javadoccomment">	 * @return The set of all direct and indirect incoming transitions to the state.</em>
<a class="jxr_linenumber" name="L153" href="#L153">153</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Collection&lt;Transition&gt; allIncomings(State state) {
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 		EList&lt;Transition&gt; allIncoming = <strong class="jxr_keyword">new</strong> BasicEList&lt;Transition&gt;();
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 		<strong class="jxr_keyword">for</strong> (Transition t : state.getIncomings()) {
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 			allIncoming.add(t);
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 		}
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 		allIncoming.addAll(indirectIncomings(state));
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 		<strong class="jxr_keyword">return</strong> allIncoming;
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 	}
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L164" href="#L164">164</a> <em class="jxr_javadoccomment">	 * @return The set of all direct and indirect incoming transitions to the state.</em>
<a class="jxr_linenumber" name="L165" href="#L165">165</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Collection&lt;Transition&gt; allOutgoings(State state) {
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 		EList&lt;Transition&gt; allIncoming = <strong class="jxr_keyword">new</strong> BasicEList&lt;Transition&gt;();
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 		<strong class="jxr_keyword">for</strong> (Transition t : state.getIncomings()) {
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 			allIncoming.add(t);
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 		}
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 		allIncoming.addAll(indirectOutgoings(state));
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 		<strong class="jxr_keyword">return</strong> allIncoming;
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 	}
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L176" href="#L176">176</a> <em class="jxr_javadoccomment">	 * Adds all the inner elements of a composite state to self, except for the</em>
<a class="jxr_linenumber" name="L177" href="#L177">177</a> <em class="jxr_javadoccomment">	 * initial, entry, exit and history pseudo-states.</em>
<a class="jxr_linenumber" name="L178" href="#L178">178</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L179" href="#L179">179</a> <em class="jxr_javadoccomment">	 * This operation moves those elements, as it removes them from their</em>
<a class="jxr_linenumber" name="L180" href="#L180">180</a> <em class="jxr_javadoccomment">	 * original container and sets their owner to the recipient.</em>
<a class="jxr_linenumber" name="L181" href="#L181">181</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> moveContents(Region targetRegion, State source) {
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 		Region sourceRegion = region(source);
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 		EList&lt;Vertex&gt; vertices = <strong class="jxr_keyword">new</strong> BasicEList&lt;Vertex&gt;(sourceRegion.getSubvertices());
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 		<strong class="jxr_keyword">for</strong> (Vertex v : vertices) {
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 			<em class="jxr_comment">// move states and pseudostates</em>
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 			targetRegion.getSubvertices().add(v);
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 		}
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 		EList&lt;Transition&gt; transitions = <strong class="jxr_keyword">new</strong> BasicEList&lt;Transition&gt;(sourceRegion.getTransitions());
<a class="jxr_linenumber" name="L190" href="#L190">190</a> 		<strong class="jxr_keyword">for</strong> (Transition t : transitions) {
<a class="jxr_linenumber" name="L191" href="#L191">191</a> 			targetRegion.getTransitions().add(t);
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 		}
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 	}
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Pseudostate initialState(Region region) {
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 		<strong class="jxr_keyword">return</strong> firstPseudoState(region, PseudostateKind.INITIAL_LITERAL);
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 	}
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 
<a class="jxr_linenumber" name="L199" href="#L199">199</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Pseudostate deepHistory(Region region) {
<a class="jxr_linenumber" name="L200" href="#L200">200</a> 		<strong class="jxr_keyword">return</strong> firstPseudoState(region, PseudostateKind.DEEP_HISTORY_LITERAL);
<a class="jxr_linenumber" name="L201" href="#L201">201</a> 	}
<a class="jxr_linenumber" name="L202" href="#L202">202</a> 
<a class="jxr_linenumber" name="L203" href="#L203">203</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> State createState(Region region, String name) {
<a class="jxr_linenumber" name="L204" href="#L204">204</a> 		<strong class="jxr_keyword">return</strong> (State) region.createSubvertex(name, UMLPackage.eINSTANCE.getState());
<a class="jxr_linenumber" name="L205" href="#L205">205</a> 	}
<a class="jxr_linenumber" name="L206" href="#L206">206</a> 
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Pseudostate createPseudostate(Region region, String name) {
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 		<strong class="jxr_keyword">return</strong> (Pseudostate) region.createSubvertex(name, UMLPackage.eINSTANCE.getPseudostate());
<a class="jxr_linenumber" name="L209" href="#L209">209</a> 	}
<a class="jxr_linenumber" name="L210" href="#L210">210</a> 	
<a class="jxr_linenumber" name="L211" href="#L211">211</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L212" href="#L212">212</a> <em class="jxr_javadoccomment">	 * Return the bound package in the context of template instantiation for a given actual.</em>
<a class="jxr_linenumber" name="L213" href="#L213">213</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L214" href="#L214">214</a> <em class="jxr_javadoccomment">	 * This is required by the state machine template which needs to access operation IDs</em>
<a class="jxr_linenumber" name="L215" href="#L215">215</a> <em class="jxr_javadoccomment">	 * provided by the call interceptor.</em>
<a class="jxr_linenumber" name="L216" href="#L216">216</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L217" href="#L217">217</a> <em class="jxr_javadoccomment">	 * @param actual</em>
<a class="jxr_linenumber" name="L218" href="#L218">218</a> <em class="jxr_javadoccomment">	 *            The actual for template binding</em>
<a class="jxr_linenumber" name="L219" href="#L219">219</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L220" href="#L220">220</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Package boundPackageRef(Type actual) {
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 		<strong class="jxr_keyword">for</strong> (Package nestedPkg : PackageUtil.getRootPackage(actual).getNestedPackages()) {
<a class="jxr_linenumber" name="L223" href="#L223">223</a> 			<em class="jxr_comment">// search for bound package templates who are bound to the same actual</em>
<a class="jxr_linenumber" name="L224" href="#L224">224</a> 			<em class="jxr_comment">// TODO: search is ambiguous, if same actual is used more than once</em>
<a class="jxr_linenumber" name="L225" href="#L225">225</a> 			<strong class="jxr_keyword">if</strong> (nestedPkg.getTemplateBindings().size() &gt; 0) {
<a class="jxr_linenumber" name="L226" href="#L226">226</a> 				TemplateBinding binding = nestedPkg.getTemplateBindings().get(0);
<a class="jxr_linenumber" name="L227" href="#L227">227</a> 				<strong class="jxr_keyword">if</strong> (actual == TemplateUtils.getFirstActualFromBinding(binding)) {
<a class="jxr_linenumber" name="L228" href="#L228">228</a> 					<strong class="jxr_keyword">return</strong> nestedPkg;
<a class="jxr_linenumber" name="L229" href="#L229">229</a> 				}
<a class="jxr_linenumber" name="L230" href="#L230">230</a> 			}
<a class="jxr_linenumber" name="L231" href="#L231">231</a> 		}
<a class="jxr_linenumber" name="L232" href="#L232">232</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L233" href="#L233">233</a> 	}
<a class="jxr_linenumber" name="L234" href="#L234">234</a> 
<a class="jxr_linenumber" name="L235" href="#L235">235</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L236" href="#L236">236</a> <em class="jxr_javadoccomment">	 * Declares a dependency from the current classifier which is produced by template instantiation</em>
<a class="jxr_linenumber" name="L237" href="#L237">237</a> <em class="jxr_javadoccomment">	 * to the element (enum) "OperationIDs", if found within the passed package.</em>
<a class="jxr_linenumber" name="L238" href="#L238">238</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L239" href="#L239">239</a> <em class="jxr_javadoccomment">	 * @param pkg</em>
<a class="jxr_linenumber" name="L240" href="#L240">240</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L241" href="#L241">241</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L242" href="#L242">242</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> declareDependencyToOperationIDs(Package pkg) {
<a class="jxr_linenumber" name="L243" href="#L243">243</a> 		PackageableElement type = pkg.getPackagedElement(<span class="jxr_string">"OperationIDs"</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L244" href="#L244">244</a> 		<strong class="jxr_keyword">if</strong> (type instanceof Type) {
<a class="jxr_linenumber" name="L245" href="#L245">245</a> 			ElementUtils.declareDependency(TransformationContext.current.classifier, (Type) type);
<a class="jxr_linenumber" name="L246" href="#L246">246</a> 		}
<a class="jxr_linenumber" name="L247" href="#L247">247</a> 	}
<a class="jxr_linenumber" name="L248" href="#L248">248</a> 
<a class="jxr_linenumber" name="L249" href="#L249">249</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L250" href="#L250">250</a> <em class="jxr_javadoccomment">	 * Declares a dependency from the current classifier which is produced by template instantiation</em>
<a class="jxr_linenumber" name="L251" href="#L251">251</a> <em class="jxr_javadoccomment">	 * to the element (enum) "SignalIDs", if found within the passed package.</em>
<a class="jxr_linenumber" name="L252" href="#L252">252</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L253" href="#L253">253</a> <em class="jxr_javadoccomment">	 * @param pkg</em>
<a class="jxr_linenumber" name="L254" href="#L254">254</a> <em class="jxr_javadoccomment">	 *            the package in which an enumeration is looked up</em>
<a class="jxr_linenumber" name="L255" href="#L255">255</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L256" href="#L256">256</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L257" href="#L257">257</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> declareDependencyToSignalIDs(Package pkg) {
<a class="jxr_linenumber" name="L258" href="#L258">258</a> 		NamedElement type = ElementUtils.getQualifiedElement(pkg, <span class="jxr_string">"globalenums::"</span> + SIGNAL_ENUM); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L259" href="#L259">259</a> 		<strong class="jxr_keyword">if</strong> (type instanceof Type) {
<a class="jxr_linenumber" name="L260" href="#L260">260</a> 			ElementUtils.declareDependency(TransformationContext.current.classifier, (Type) type);
<a class="jxr_linenumber" name="L261" href="#L261">261</a> 		}
<a class="jxr_linenumber" name="L262" href="#L262">262</a> 	}
<a class="jxr_linenumber" name="L263" href="#L263">263</a> 	
<a class="jxr_linenumber" name="L264" href="#L264">264</a> 	<strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String SIGNAL_ENUM = <span class="jxr_string">"SignalIDs"</span>;  <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L265" href="#L265">265</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
